import AccessControl
import OFS, Globals
from OFS import SimpleItem
import types
import time
from TraversableWrapper import Traversable
from Globals import Persistent
from AccessControl import ClassSecurityInfo
from Cruft import Cruft
from common import add_dtml
#import TestiYlesanne
import YlVahendus
from YlVahendus import YlVahendus
#from TestiYlesanne import TestiYlesanne
     
        
                   
class YlTest(
     OFS.Folder.Folder,
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):
    "lesannetest koosnev test"
    meta_type='YlTest'
    pealkiri=""
    nr=0
    avatudTaitmiseks=0
    
    security=ClassSecurityInfo()
    security.declareObjectPublic()
    
    
    def __init__(self):
       "Alustus"
       self.koigiLuba=LahendusLuba()
       self.grupiLoad=LahendusLoad()
       self.isikuLoad=LahendusLoad()
       self.vahendus=YlVahendus()
      
    def lisaYlesanne(self, yl):
       "uus lesanne testis"
       if yl is None: return
       self.nr=self.nr+1
       yl.id="yl"+str(self.nr)
       self._setObject(yl.id, yl)
       
    def lisaYlesanded(self, ylmassiiv):
       "Lisatakse lesannete massiiv"
       for x in ylmassiiv:
         self.lisaYlesanne(x)
         
    def ylesandedTekstina(self):
       "Vljastab lesanded HotPotatos ekspordina"
       tulemus=""
       yl=self.ylesanded()
       for i in range(len(yl)):
         tulemus=tulemus+yl[i].kirjutaYlesanneTekstiks(self.pealkiri, i+1)
       return tulemus
       
    def kysimused(self):
       "Ksimuste loetelu"
       k=[]
       for x in self.ylesanded():
         k.append(x.kysimus)
       return k
       
    def ylesanded(self):
       "lesannete loetelu"
       return self.objectValues()
     
    def annaPealkiri(self):
       "Testi nimi"
       try:
         return self.pealkiri    
       except:
         return ""
         
    def pealkiriHTML(self, REQUEST):
       "Pealkiri HTMLina"
       return asendaHTML(self.annaPealkiri())

    def pealkirjaEsitlus(self, REQUEST):
       "Nimi mens"
       if self.pealkiriHTML(REQUEST)!="":
         return self.pealkiriHTML(REQUEST)+" ("+self.getId()+")"
       else:
         return self.getId()
         
    def seaPealkiri(self, pealkiri):
       "Pealkirja salvestus"
       self.pealkiri=pealkiri
       
    def pealkirjaMuutmisVormHTML(self, REQUEST, liikumisURL):
       "Leht pealkirja muutuse sisestuseks"
       tulemus=leheAlgus(self, REQUEST)
       tulemus=tulemus+self.pealkirjaMuutmisVorm(REQUEST, liikumisURL)
       tulemus=tulemus+leheLopp(self, REQUEST)
       return tulemus
       
    def pealkirjaMuutmisVorm(self, REQUEST, liikumisURL=""):
       "Vorm pealkirja muutmiseks"
       self.get_lang(('ivatests',), REQUEST)
       return "<form action='pealkirjaMuutmisLeht'>"\
         "<input type='text' name='pealkiri' value='"+self.annaPealkiri()+"' />"+\
         "<input type='submit' value='"+REQUEST['L_it_save_title']+"' />"+\
         "<input type='hidden' name='liikumisURL' value="+liikumisURL+">"+\
         "</form>"
         
    def pealkirjaMuutmisLeht(self, REQUEST, pealkiri, liikumisURL=""):
       "Pealkirja salvestus"
       self.seaPealkiri(pealkiri)
       if liikumisURL=='':
         liikumisURL='ylesandedMuutmisTabelina';
#       REQUEST.RESPONSE.redirect('ylesandedMuutmisTabelina')
       REQUEST.RESPONSE.redirect(liikumisURL)
     
       
       
    def ylesanneteArv(self):
       "lesannete arv"
       return len(self.ylesanded())
       
    def tutvustus(self):
       "Testi tutvutus"
       return "Lahendamiseks meldud test"
       
    def kasLubatudLahendada(self, REQUEST):
       "Arvutus lubade kaudu"
       n=self.lahendusKordadeArv(REQUEST)
       if self.koigiLuba.kasLubatudLahendada(REQUEST, n):return 1
       if hasattr(self.isikuLoad, str(REQUEST.AUTHENTICATED_USER)):
         if getattr(self.isikuLoad, str(REQUEST.AUTHENTICATED_USER)).kasLubatudLahendada(REQUEST, n):
           return 1
       for x in self.find_course().sisegrupid.objectValues():
         if str(REQUEST.AUTHENTICATED_USER) in x.get_local_roles():
           if hasattr(self.grupiLoad, x.id):
             if getattr(self.grupiload, x.id).kasLubatudLahendada(REQUEST, n):
                return 1
       return 0
       
    def lubadeViited(self, REQUEST):
       "Viited lubadele"
       self.get_lang(('ivatests',), REQUEST)
       tulemus=leheAlgus(self, REQUEST)+"<h3>"+REQUEST['L_it_description_of_permissions']+"</h3><ul>"
       tulemus=tulemus+"<li><a href='koigiLuba'>"+REQUEST['L_it_all_permission']+"Kigi juurdeps</a></li>"+\
         "<li>"+REQUEST['L_it_inner_groups_permission']+"</li><ul>"
       for x in self.grupiLoad.objectValues():
         tulemus=tulemus+"\n<li><a href='"+x.absolute_url()+"'>"+x.id+"</a></li>"
       tulemus=tulemus+"</ul><li>"+REQUEST['L_it_user_permission']+"</li><ul>"
       for x in self.isikuLoad.objectValues():
         tulemus=tulemus+"\n<li><a href='"+x.absolute_url()+"'>"+x.id+"</a></li>"
       tulemus=tulemus+"</ul>"+leheLopp(self, REQUEST)
       return tulemus
              
    def isikuLubadeLisamisVorm(self, REQUEST):
       "Valida, kellel lubada"
       self.get_lang(('ivatests',),REQUEST)
       tulemus=leheAlgus(self, REQUEST)+"<form action='isikuLubadeLisamisLeht'>"
       isikud=self.find_course().get_all_users_id()
       loagaIsikud=self.isikuLoad.nimedeLoetelu()
       for x in isikud:
          if x not in loagaIsikud:
            tulemus=tulemus+"<br />\n<input type='checkbox' name='nimed' value='"+x+"'/>"+x               
       tulemus=tulemus+"<br /><input type='submit' value='"+REQUEST['L_it_add_user_permission']+"' />"
       return tulemus+"</form>"+leheLopp(self, REQUEST)
       
    def isikuLubadeLisamisLeht(self, REQUEST, nimed=None):
       "Nimede salvestus"
       if nimed is not None:
         if type(nimed) is types.StringType:
           nimed=(nimed,)
         for x in nimed:
           luba=LahendusLuba()
           luba.id=x
           self.isikuLoad._setObject(luba.id, luba)       
       REQUEST.RESPONSE.redirect('lubadeViited')
       
    def grupiLubadeLisamisVorm(self, REQUEST):
       "Valida, kellel lubada"
       self.get_lang(('ivatests',), REQUEST)
       tulemus=leheAlgus(self, REQUEST)+"<form action='grupiLubadeLisamisLeht'>"
       grupid=self.find_course().sisegrupid.objectValues()
       loagaGrupid=self.grupiLoad.nimedeLoetelu()
       for x in grupid:
          if x not in loagaGrupid:
            tulemus=tulemus+"<br />\n<input type='checkbox' name='nimed' value='"+x+"'/>"+x               
       tulemus=tulemus+"<br /><input type='submit' value='"+REQUEST['L_it_add_group_permission']+"' />"
       return tulemus+"</form>"+leheLopp(self, REQUEST)
       
    def grupiLubadeLisamisLeht(self, REQUEST, nimed=None):
       if nimed is not None:
         if type(nimed) is types.StringType:
           nimed=(nimed,)
         for x in nimed:
           luba=LahendusLuba()
           luba.id=x
           self.grupiLoad._setObject(luba.id, luba)       
       REQUEST.RESPONSE.redirect('lubadeViited')
       

    def kasAvatudTaitmiseks(self):
       "Teatab, kas opilastele on test nahtav"
       try:
         return self.avatudTaitmiseks
       except:
         return 0

    def seaAvatudTaitmiseks(self, seisund, REQUEST):
       "Saab oelda, kas avatud"
       if int(seisund)==1:
         self.avatudTaitmiseks=1
       else: 
         self.avatudTaitmiseks=0
       #return str(self.avatudTaitmiseks)
       REQUEST.RESPONSE.redirect('index_html')
       
    def muudaAvatudTaitmiseks(self, REQUEST):
       "Vahetab seisundi"
       if self.avatudTaitmiseks==1:
         self.avatudTaitmiseks=0
       else:
         self.avatudTaitmiseks=1
       return str(self.avatudTaitmiseks)+" kuku"
       
    def ylesanneteTyypideLoetelu(self, REQUEST):
        "Vljakutse"
        return leheAlgus(self, REQUEST)+self.vahendus.ylesanneteTyypideLoetelu(REQUEST)+leheLopp(self, REQUEST)
        
    def lisaUusYlesanne(self, REQUEST, tyyp):
        "lesande lisamine" 
        yl=self.vahendus.lisaUusYlesanne(REQUEST, tyyp)
#        return "Jah 2"
        self.lisaYlesanne(yl)
        REQUEST.RESPONSE.redirect(self.absolute_url()+"/"+yl.id+"/muutmisVorm?liikumisURL="+self.absolute_url())
        #return (self.absolute_url()+yl.id+"/muutmisVorm&liikumisURL="+self.absolute_url())
        #REQUEST.RESPONSE.redirect('ylesandedMuutmisTabelina')

    def ylesandedTabelina(self, REQUEST):
        "lesanded tabelina"
        m=self.ylesanded()
        tulemus=leheAlgus(self, REQUEST)+self.pealkirjaEsitlus(REQUEST)+"<table>"
        for x in m:
          tulemus=tulemus+"\n<tr><td>"+x.esitlusHTML(REQUEST)+"<td>"+\
            "<td>"+x.vaatamineHTML(REQUEST)+"</td>"+\
            "<td>"+x.marksonadHTML(REQUEST)+"</td>"+\
            "<td>"+x.ylesanne.ylesandeNimetus(REQUEST)+"</td></tr>"
        tulemus=tulemus+"</table>"
        return tulemus+leheLopp(self, REQUEST)


    def ylesandedMuutmisTabelina(self, REQUEST):
        "lesanded koos viidetega kustutamiseks ja muutmiseks"
        #import urllib
        #return "Tere"
 #       from TestiYlesanne import TestiYlesanne
        self.get_lang(('ivatests',), REQUEST)
        tulemus=leheAlgus(self, REQUEST)+self.vahendus.ylesanneteTyybidValikuna(REQUEST) 
        if len(self.ylesanded())>0:        
         tulemus=tulemus+"<form action='kustuta_leht'><table>"+\
          "<tr><td>"+REQUEST['L_it_deletion']+"</td><td>"+REQUEST['L_it_question']+"</td><td>"+REQUEST['L_it_answer']+"</td><td>"+REQUEST['L_it_type']+"</td><td>"+REQUEST['L_it_points']+"</td><td>"+REQUEST['L_it_change']+"</td></tr>"
         for x in self.ylesanded():
          tulemus=tulemus+"\n<tr>"+\
            "<td><input type='checkbox' name='kustuta' value='"+x.id+"' />"+"</td>"+\
            "<td>"+x.esitlusHTML(REQUEST)+"</td>"+\
            "<td>"+x.vaatamineHTML(REQUEST)+"</td>"+\
            "<td>"+x.ylesandeNimetus(REQUEST)+"</td>"+\
            "<td>"+x.normPunktidHTML(REQUEST)+"</td>"+\
            "<td><a href='"+x.id+"/muutmisVorm?liikumisURL="+self.absolute_url()+"'>"+REQUEST['L_it_change']+"</a></td>"+\
            "</tr>"
         tulemus=tulemus+"</table><input type='submit' value='"+REQUEST['L_it_deletion']+"' /></form>"+\
           "\n<br />"
#        avatuArv=1
#        avatuTekst=REQUEST['L_it_make_public']
#        if self.avatudTaitmiseks:
#          avatuArv=0
#          avatuTekst=REQUEST['L_it_hide']
#        tulemus=tulemus+"<a href='ylesanneteTyypideLoetelu'>"+REQUEST['L_it_add_exercise']+"</a>"+\
#          "<br /><a href='seaAvatudTaitmiseks?seisund="+str(avatuArv)+"'>"+avatuTekst+" test</a>"+\
#          "<br /><a href='kasutajateTulemused'>"+REQUEST['L_it_results_from_users']+"</a><br />"
#        tulemus=tulemus+"<br />"+self.vahendus.ylesanneteTyypideLoetelu(REQUEST)+"<hr />"+\
#                "<a href='vahendus/tekstistYlesanneteLaadimiseVorm'>"+REQUEST['L_it_import_from_hotpotatoes']+"</a><br />"+\
#                "<a href='ylesandedTekstina'>"+REQUEST['L_it_export_to_web_ct']+"</a>"
#        return "Terekest 3"
        return tulemus+leheLopp(self, REQUEST)
        


    def kustuta_leht(self, REQUEST, kustuta=None):
        "lesannete kustutamise leht"
        if kustuta is None:
           kustuta=()
        if type(kustuta) is types.StringType:
           kustuta=(kustuta,)
        for x in kustuta:
           self._delObject(x)
        REQUEST.RESPONSE.redirect('ylesandedMuutmisTabelina')
        
    def ylTyyp(self, REQUEST, ylid):
       "Ksitud ID-ga lesande tp"
       if hasattr(self, ylid):
         return self.ylid.ylesandeNimetus(REQUEST)
       return None

       
    def taidaVorm(self, REQUEST):
      "Titmisvorm"
      self.get_lang(('ivatests',), REQUEST)
      tulemus=leheAlgus(self, REQUEST)+"<h3>"
      tulemus=tulemus+REQUEST['L_it_solving_test'] % self.pealkirjaEsitlus(REQUEST)
      tulemus=tulemus+"""</h3>
         <form action="loeAndmedLehelt">
           <table>
       """ 
      for x in self.ylesanded():
            tulemus=tulemus+"\n<tr><td>"+x.esitlusHTML(REQUEST)+"</td>"+\
            "<td>"+x.taitmineHTML(REQUEST, x.id) + "</td></tr>"
      tulemus=tulemus+"""
               </table>
               <input type="submit" value="""+REQUEST['L_it_save_solved_test']+""" />
               </form>
               """
      return tulemus+leheLopp(self, REQUEST)
       
    def index_html(self, REQUEST):
       "Peegel veebi"
       if self.kas_opetaja(self, REQUEST):
         #return self.ylesandedMuutmisTabelina(REQUEST)
         REQUEST.RESPONSE.redirect(self.absolute_url()+"/ylesandedMuutmisTabelina")
       else:
         return self.taidaVorm(REQUEST)


    def loeAndmedLehelt(self, REQUEST):
        "Veebilt tulevad andmed talde"
        self.get_lang(('ivatests',), REQUEST)
        tulemus=""
        t=TestiVastused()
        t.testinimi=self.id
        for x in self.ylesanded():
          vastus=None
          if hasattr(REQUEST, x.id):
            vastus=getattr(REQUEST, x.id)
          tulemus=tulemus+"!"+x.id+" "+str(vastus)
          t._setObject(x.id, x.salvestaPakutu(vastus))
        self.paigutaTestiVastus(REQUEST, t)
        return leheAlgus(self, REQUEST)+"<br /><b>"+REQUEST['L_it_answers_saved']+"</b>"+leheLopp(self, REQUEST)
        
  #  def salvestusAsukoht(self, REQUEST, testinimi='nimetu'):
  #     "Koht testi tulemuste salvestamiseks"
  #     kasutaja=getattr(getattr(self.fle_root().fle_users, str(REQUEST.AUTHENTICATED_USER)).webtop, 'wt5')
  #     if not hasattr(kasutaja, 'testid'):
  #        kasutaja.manage_addProduct['OFSP'].manage_addFolder('testid')
  #        #kasutaja._setObject('testid', TestiVastused())
  #     if not hasattr(kasutaja.testid, testinimi):
  #        kasutaja.testid.manage_addProduct['OFSP'].manage_addFolder(testinimi)
  #        testikataloog=getattr(kasutaja.testid, testinimi)
  #        testikataloog.variandinr=0
  #     testikataloog=getattr(kasutaja.testid, testinimi)
  #     #return self.get_url_to_object(testikataloog)
  #     return testikataloog
  

    def salvestusAsukoht(self, REQUEST, testinimi='nimetu'):
       "Koht testi tulemuste salvestamiseks"
       kasutajajuur=getattr(self.fle_root().fle_users,\
                   str(REQUEST.AUTHENTICATED_USER))
       try:
        kasutaja=getattr(kasutajajuur.webtop,\
          'c'+kasutajajuur.get_jooksev_kursus())
       except:
        kasutaja=kasutajajuur.webtop
       if not hasattr(kasutaja, 'testivastused'):
          kasutaja.manage_addProduct['OFSP'].manage_addFolder('testivastused')
          kasutaja.testivastused.id='testivastused'
       if not hasattr(kasutaja.testivastused.aq_self, testinimi):
          kasutaja.testivastused.manage_addProduct['OFSP'].manage_addFolder(testinimi)
          testikataloog=getattr(kasutaja.testivastused, testinimi)
          testikataloog.id=testinimi
          testikataloog.variandinr=0
       testikataloog=getattr(kasutaja.testivastused, testinimi)
       #return self.get_url_to_object(testikataloog)
       return testikataloog

    def paigutaTestiVastus(self, REQUEST, vastus):
       "Paigutab variandi uue id alla"
       self.get_lang(('ivatests',), REQUEST)
       k=self.salvestusAsukoht(REQUEST, vastus.testinimi)
#       if not hasattr(k, 'variandinr'):
#          k.variandinr=0
       k.variandinr=k.variandinr+1
       vastus.id="variant"+str(k.variandinr)
#       vastus.id=REQUEST['L_it_answer_instance']+str(k.variandinr)
       k._setObject(vastus.id, vastus)
       print "salvestati "+vastus.id+" "+k.absolute_url()
       return str(k.variandinr)
       
    def lahenduskordadeArv(self, REQUEST):
       "Mitu varianti on kasutaja vastavat testi lahendanud"
       k=self.salvestusAsukoht(REQUEST, self.id)
       return len(k.objectValues())

    def kasutajateTulemused(self, REQUEST, kommentaarid=0):
       "Testi tulemused"
       self.get_lang(('ivatests',), REQUEST)
       tulemus=leheAlgus(self, REQUEST)+"<h3>"+(REQUEST['L_it_test_answers'] % self.id)+"</h3><ul>"
       try:
         kasutajad=self.get_all_users()
       except:
         return tulemus+REQUEST['L_it_problem_in_finding_user']
       for x in kasutajad:
        tulemus=tulemus+"<li>"+str(x.id)+"</li>"
#        try:
        k=getattr(x.webtop, 'c'+str(self.find_course().get_id()))
           #tulemus=tulemus+"j"+k.absolute_url()
        if hasattr(k, 'testivastused'):
             #tulemus=tulemus+"k"
             if hasattr(k.testivastused, self.id):               
               t=getattr(k.testivastused, self.id)
               tulemus=tulemus+"<ul>"
               for y in t.objectValues():
                 print type(y)
                 tulemus=tulemus+"<li><a href='"+y.absolute_url()+"'>"+str(y.id)+"</a> "
                 if kommentaarid:
                   tulemus=tulemus+str(y.lyhiKokkuvoteOpetajale(REQUEST))
                 else:
                   tulemus=tulemus+str(y.punktiArvutusHTML(REQUEST))
                 tulemus=tulemus+"</li>"
               tulemus=tulemus+"</ul>"
#        except Exception, probleem:
#          tulemus=tulemus+" "+str(probleem)
       return tulemus+"</ul>"+leheLopp(self, REQUEST)


  
       
    def leivaPuru(self, REQUEST, viimane=0):
       "Teekond les"
       self.get_lang(('ivatests',),REQUEST)
       nimi=self.id
       if viimane:
         tekst=nimi
       else:
         tekst="<a href='"+self.absolute_url()+"'>"+nimi+"</a>"
       if self.kas_opetaja(self, REQUEST):
#          pass
         return " &gt; <a href='"+self.fle_root().testihaldus.absolute_url()+"'>"+REQUEST["L_it_hdr_tests"]+"</a> &gt; " + tekst
       return " &gt; "+tekst
       
#    def paigutaTestiVastus(self, REQUEST, vastus):
#       "Paigutab variandi uue id alla"
#       k=self.salvestusAsukoht(REQUEST, vastus.id)
#       k.variandinr=k.variandinr+1
#       #vastus=ValikTest()
#       k._setObject("variant"+str(k.variandinr), vastus)
#       return str(k.variandinr)

#Globals.default__class_init__(YlTest)
Globals.InitializeClass(YlTest)

class LahendusLoad(Persistent, OFS.Folder.Folder, Traversable):
   "Lahenduslubade kogum"
   def leivaPuru(self, REQUEST, viimane=0):
     "Teekond les"
     nimi=self.id+" lahendusaeg"
     if viimane:
         tekst=nimi
     else:
         tekst="<a href='"+self.absolute_url()+"'>"+nimi+"</a>"
     return self.aq_parent.leivaPuru(REQUEST)+" &gt; "+tekst
       
   def kustutusleht(self, REQUEST, kustuta=None):
     "iguslubade kustutamine"
     if kustuta is not None:
       if type(kustuta)==types.StringType:
         kustuta=(kustuta,)
       for x in kustuta:
         self._delObject(x)
     REQUEST.RESPONSE.redirect('index_html')
     
   def nimedeLoetelu(self):
     "Elementide nimed tekstina"
     nimed=[]
     for x in self.objectValues():
       nimed.append(x.id)
     return nimed
       
   def index_html(self, REQUEST):
     "Lubade loetelu"
     self.get_lang(('ivatests',), REQUEST)
     tulemus=leheAlgus(self, REQUEST)+"<form action='kustutusLeht'><ul>"
     for x in self.objectValues():
       tulemus=tulemus+"\n<li><input type='checkbox' name='kustuta' value='"+x.id+"'><a href='"+x.absolute_url()+"'>"+x.id+"</a></li>"
     tulemus=tulemus+"</ul><input type='submit' value='"+REQUEST['L_it_delete_permission']+"' /></form>"+leheLopp(self, REQUEST)
     return tulemus

class LahendusLuba(Persistent, OFS.SimpleItem.Item, Traversable):
   "igused testi lahendamiseks"
   kordadeArv=-1  #arvu ei piirata
   algusAeg=-1    #Pole avatud lahendamiseks
   loppAeg=-1     #Kestust ei piirata
   import time
   def kasLahendusAeg(self):
     "jah/ei praeguse hetke kohta"
     if algusAeg==-1: return 0
     if algusAeg>time.time():return 0
     if loppAeg==-1:return 1
     if loppAeg>time.time():return 1
     else: return 0
     
   def kasLubatudLahendada(self, tehtudKordadeArv):
     "Jah/ei"
     if self.kasLahendusAeg()==0:return 0
     if self.kordadeArv==-1: return 1
     return tehtudKordadeArv<self.kordadeArv
     
   def looValik(self, elemendinimi, algus, ots, valitu=-1):
      "Valikmen HTML"
      tulemus="<select name='"+elemendinimi+"'>"
      for x in range(algus, ots):
        tulemus=tulemus+"\n <option value='"+str(x)+"'"
        if valitu==x:
          tulemus=tulemus+" selected "
        tulemus=tulemus+">"+str(x)+"</option>"
      tulemus=tulemus+"\n</select>"
      return tulemus

   def ajaMuutmisElemendid(self, elemendinimi, aeg=time.time()):
     "Valikute kogum"
     if aeg==-1:aeg=time.time()
     m=time.localtime(aeg)
     tulemus=self.looValik(elemendinimi+"Aasta", m[0]-1, m[0]+10, m[0])
     tulemus=tulemus+"-"+\
             self.looValik(elemendinimi+"Kuu", 1, 12, m[1])
     tulemus=tulemus+"-"+\
             self.looValik(elemendinimi+"Paev", 1, 31, m[2])
     tulemus=tulemus+" &nbsp; "+\
             self.looValik(elemendinimi+"Tund", 0, 23, m[3])
     tulemus=tulemus+":"+\
             self.looValik(elemendinimi+"Minut", 0, 59, m[4])
     return tulemus
     
   def ajaPyydmisLeht(self, REQUEST, elemendinimi):
     "Saabuvad parameetrid ajaks"
     m=(int(getattr(REQUEST, elemendinimi+"Aasta")),
        int(getattr(REQUEST, elemendinimi+"Kuu")),
        int(getattr(REQUEST, elemendinimi+"Paev")),
        int(getattr(REQUEST, elemendinimi+"Tund")),
        int(getattr(REQUEST, elemendinimi+"Minut")),0,0,0,0)
     return time.mktime(m)
          
     
   def muutmisVorm(self, REQUEST):
     "Vljund veebilehele"
     self.get_lang(('ivatests',), REQUEST)
     tulemus=leheAlgus(self, REQUEST)+\
       "<form action='muutmisLeht'>"
     tulemus=tulemus+"<h3>Algusaeg</h3>"+\
       self.ajaMuutmisElemendid("algusAeg", self.algusAeg)+\
       "<h3>Lppaeg</h3>"+\
       self.ajaMuutmisElemendid("loppAeg", self.loppAeg)+\
       "<br /><input type='submit' value='Salvesta' />"
     tulemus=tulemus+"</form>"+leheLopp(self, REQUEST)
     return tulemus
     
   def muutmisLeht(self, REQUEST):
     "Tulemuste talletus"
     self.algusAeg=self.ajaPyydmisLeht(REQUEST, "algusAeg")
     self.loppAeg=self.ajaPyydmisLeht(REQUEST, "loppAeg")
     REQUEST.RESPONSE.redirect('muutmisVorm')
     
   def index_html(self, REQUEST):
     "Avaleht"
     return self.muutmisVorm(REQUEST)

   def leivaPuru(self, REQUEST, viimane=0):
     "Teekond les"
     nimi=self.id+" lahendusaeg"
     if viimane:
         tekst=nimi
     else:
         tekst="<a href='"+self.absolute_url()+"'>"+nimi+"</a>"
     return self.aq_parent.leivaPuru(REQUEST)+" &gt; "+tekst
       
     
     
     
   
class TestiVastused(
     OFS.Folder.Folder,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):           
     "Testi vastusvariant"
     testinimi=""
     koguKommentaar=""
     
     def ylesanded(self):
       "lesannete kogum"
       return self.objectValues()
     
     
     def vastusteTabel(self, REQUEST):
       "lesannete vastused tabelina"
       self.get_lang(('ivatests',), REQUEST)
       tulemus=leheAlgus(self, REQUEST)
       tulemus=tulemus+"<br /><table>"+\
         "<tr><td>"+REQUEST['L_it_an_question']+"</td><td>"+REQUEST['L_it_an_user_answer']+"</td><td>"+REQUEST['L_it_an_teacher_answer']+"</td><td>"+REQUEST['L_it_an_points']+"</td><td>"+REQUEST['L_it_an_comment']+"</td></tr>"
       for x in self.ylesanded():
          p="x"
          if x.kasPunktiArvutus():
            p=str(x.punkte())+"/"+str(x.normPunktid)
          tulemus=tulemus+"\n<tr><td>"+x.esitlusHTML(REQUEST)+"</td><td>"+\
          x.pakutudHTML(REQUEST)+"</td><td>"+x.tegelikHTML(REQUEST)+"</td><td>"+p+"</td><td>"+x.opetajaKommentaarHTML(REQUEST)+"</td></tr>"
       tulemus=tulemus+"</table><br />"+self.punktiArvutusHTML(REQUEST)+"<br />"+self.koguKommentaarHTML(REQUEST)+"<br />"
       if self.kas_opetaja(self, REQUEST):
         tulemus=tulemus+"<a href='vastusteKommenteeritavTabel'>"+REQUEST['L_it_an_answer_commenting_table']+"</a>"
       return tulemus+leheLopp(self, REQUEST)

     def vastusteKommenteeritavTabel(self, REQUEST):
       "lesannete vastused tabelina"
       self.get_lang(('ivatests',), REQUEST)
       tulemus=leheAlgus(self, REQUEST)+\
       "<form action='kommentaarideSalvestusLeht'><table>"+\
         "<tr><td>"+REQUEST['L_it_anc_question']+"</td><td>"+REQUEST['L_it_anc_user_answer']+"</td><td>"+REQUEST['L_it_anc_teacher_answer']+"</td>"+\
              "<td>"+REQUEST['L_it_anc_automatic_points']+"</td><td>"+REQUEST['L_it_anc_nominal_points']+"</td><td>"+REQUEST['L_it_anc_teacher_points']+"</td><td>"+REQUEST['L_it_anc_teachers_comment']+"</td><td>"+REQUEST['L_it_anc_point_reading']+"</td></tr>"
       for x in self.ylesanded():
          opunktid=""
          if x.annaOpetajaPunktid() is not None:
            opunktid=x.annaOpetajaPunktid()
          else:
            if x.kasPunktiArvutus():
              opunktid=x.automaatPunkte()
          tulemus=tulemus+"\n<tr><td>"+x.esitlusHTML(REQUEST)+"</td><td>"+\
          x.pakutudHTML(REQUEST)+"</td><td>"+x.tegelikHTML(REQUEST)+"</td>"
          tulemus=tulemus+"<td>"+str(x.automaatPunkte())+"</td>"+\
          "<td>"+str(x.normPunktid)+"</td>"+\
          "<td><input type='text' name='opetajapunktid"+x.id+"' "+\
          " value='"+str(opunktid)+"' size='5' /></td>"
          tulemus=tulemus+\
          "<td><input type='text' name='opetajakommentaar"+x.id+"' "+\
          " value='"+str(x.annaOpetajaKommentaar())+"' /></td>"+\
          "<td>"+str(x.kasPunktiArvutus())+"</td>"+\
          "</tr>"
       tulemus=tulemus+"</table><br />"+\
        self.punktiArvutusHTML(REQUEST)+"<br />"+REQUEST['L_it_anc_comment_to_whole_answer']+":<br />"+\
        "<textarea name='koguKommentaar'>"+self.annaKoguKommentaar()+"</textarea>"+\
        "<input type='submit' value='"+REQUEST['L_it_anc_save']+"' /></form>"
       return tulemus+leheLopp(self, REQUEST)


     def kommentaarideSalvestusLeht(self, REQUEST):
       "petaja kommentaaride salvestus"
       for x in self.ylesanded():
         if hasattr(REQUEST, 'opetajapunktid'+x.id) and len(getattr(REQUEST,'opetajapunktid'+x.id))>0:
           try:
             x.seaOpetajaPunktid(int(getattr(REQUEST,'opetajapunktid'+x.id)))
             x.seaPunktiArvutus(1)
           except:
             x.seaPunktiArvutus(0)
         else:
           x.seaOpetajaPunktid(None)
           x.seaPunktiArvutus(0)
         if hasattr(REQUEST, 'opetajakommentaar'+x.id):
           x.seaOpetajaKommentaar(getattr(REQUEST, 'opetajakommentaar'+x.id))           
           
       self.seaKoguKommentaar(REQUEST.koguKommentaar)
       REQUEST.RESPONSE.redirect('vastusteKommenteeritavTabel')
       
     def seaKoguKommentaar(self, koguKommentaar):
       "Salvestatakse petaja kommentaar kogu lahendusvariandile"
       self.koguKommentaar=koguKommentaar
       
     def annaKoguKommentaar(self):
       "Kommentaari vljastus"
       return self.koguKommentaar
       
     def koguKommentaarHTML(self, REQUEST):
       "Kogu kommentaar HTML-ina"
       return asendaHTML(self.annaKoguKommentaar())
       
     def lyhiKokkuvoteOpetajale(self, REQUEST):
       "Kokkuvote"
       tulemus=self.punktiArvutusHTML(REQUEST)
       for x in self.ylesanded():
         if len(x.annaOpetajaKommentaar())>0:
           tulemus=tulemus+"<br />\n"+x.opetajaKommentaarHTML(REQUEST)
       if len(self.koguKommentaarHTML(REQUEST))>0:
         tulemus=tulemus+"<br /><br />"+self.koguKommentaarHTML(REQUEST)
       return tulemus

     def pihtasSumma(self):
       "Tabamusega ylesannete summa"
       summa=0
       for x in self.ylesanded():
         if x.kasPihtas():
           summa=summa+1
       return summa
       
     def punktiSumma(self):
        "lesannete punktisumma"
        summa=0
        for x in self.ylesanded():
          if x.kasPunktiArvutus():
            try:
             summa=summa+x.punkte()
            except Exception, probleem:
             print probleem
        return summa
        
     def normPunktiSumma(self):
        "100%"
        summa=0
        for x in self.ylesanded():
          if x.kasPunktiArvutus():
            summa=summa+x.annaNormPunktid()
        return summa
        
     def punktiProtsent(self, REQUEST):
        "%"
        self.get_lang(('ivatests',), REQUEST)
        if self.normPunktiSumma()==0:
          return "Protsendiarvutus puudub"
        return str(self.punktiSumma()*100/self.normPunktiSumma())+" %"

     def punktiArvutusHTML(self, REQUEST):
        "Tulemuste vljastus"
        self.get_lang(('ivatests',), REQUEST)        
        return str(self.punktiSumma())+" / "+str(self.normPunktiSumma())+\
           ", "+self.punktiProtsent(REQUEST)
       
     def leivaPuru(self, REQUEST, viimane=0):
       "Teekond les"
       self.get_lang(('ivatests',),REQUEST)
       nimi=self.testinimi
       if viimane:
         tekst=nimi
       else:
         tekst="<a href='"+self.absolute_url()+"'>"+nimi+"</a>"
       return " &gt; "+REQUEST['L_it_tests']+" &gt; "+tekst+" &gt; "+REQUEST['L_it_answers']+" "
       
     def index_html(self, REQUEST):
       "Peegel veebi"
       return self.vastusteTabel(REQUEST)
       
Globals.InitializeClass(TestiVastused)
Globals.default__class_init__(TestiVastused)   

def asendaHTML(sona):
   try:
    sona=sona.replace("&", "&amp;")
    sona=sona.replace(">", "&gt;")          
    sona=sona.replace("<", "&lt;")             
    return sona;
   except:
    return "kala: "+sona
           
def leheAlgus(obj, REQUEST):
   return obj.hdr(obj, REQUEST)+obj.leivaPuru(REQUEST)+"<br />"
   
def leheLopp(obj, REQUEST):
   return obj.fle_html_footer(obj, REQUEST)

